# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

VERSION = '0.2'
import Plugin
import copy

flipTable = {
	'a' : u'\u0250',
	'b' : 'q',
	'c' : u'\u0254', #open o -- from pne
	'd' : 'p',
	'e' : u'\u01DD',
	'f' : u'\u025F', #from pne
	'g' : u'\u0183',
	'h' : u'\u0265',
	'i' : u'\u0131', #from pne
	'j' : u'\u027E',
	'k' : u'\u029E',
	'l' : u'\u0283',
	'm' : u'\u026F',
	'n' : 'u',
	'r' : u'\u0279',
	't' : u'\u0287',
	'v' : u'\u028C',
	'w' : u'\u028D',
	'y' : u'\u028E',
	'.' : u'\u02D9',
	'[' : ']',
	'(' : ')',
	'{' : '}',
	'?' : u'\u00BF', #from pne
	'!' : u'\u00A1',
	"\'" : ',',
	'<' : '>',
	'_' : u'\u203E',
	'\u203F' : u'\u2040',
	'\u2045' : u'\u2046',
	'\u2234' : u'\u2235',
	'\r' : '\n' #thank you, Yeeliberto
}

leetTable = { 
	'a' : '4',
	'e' : '3',
	'i' : '1',
	'o' : '0',
	'u' : u'\u00b5'
}
flipTableFake = copy.copy(flipTable)


for i in flipTableFake:
	flipTable.__setitem__(flipTable[i],i)

class MainClass( Plugin.Plugin ):
    '''Main plugin class'''
    
    description = _('Fun with the text /l33t text and /flip text')
    authors = { 'Matheus Bratfisch' : 'matheusbrat@gmail.com' }
    website = 'http://www.matbra.com'
    displayName = _('Fun Text')
    name = 'FunText'
    
    def __init__( self, controller, msn ):
        '''Contructor'''
        
        Plugin.Plugin.__init__( self, controller, msn )
        
        self.description = _('Fun with the text /l33t text and /flip text')
    	self.authors = { 'Matheus Bratfisch' : 'matheusbrat@gmail.com' }
    	self.website = 'http://www.matbra.com'
    	self.displayName = _('Fun Text')
    	self.name = 'FunText'
        self.controller = controller
        self.Slash = controller.Slash
    
    def start( self ):
        '''start the plugin'''
        self.Slash.register('flip', self.flip, _('Flip the text'))
        self.Slash.register('l33t', self.leet, _('L33t the text'))
        self.enabled = True
    
    def replaceString(self, message, table):
		last = len(message) - 1 
		a = []
		messageNew = ""
		for i in range(last,-1,-1):
			try:
				if table[message[i]] is not None:
					a.append(table[message[i]])
			except:
				a.append(message[i])
	        
		return ''.join(a)	
	
    def leet( self, slash_action):
    	data = slash_action.getParams()
    	message = self.replaceString(data.lower(), leetTable)
        slash_action.outputText( message[::-1], True )
        
    def flip( self, slash_action ):
        '''Return Flip Text'''
        data = slash_action.getParams()
        message = self.replaceString(data.lower(), flipTable)
        slash_action.outputText( message, True )

    def stop( self ):    
        '''stop the plugin'''
        self.Slash.unregister('flip')
        self.enabled = False

    def check( self ):
        '''Check Plugin'''
        return ( True, 'Ok' )
